﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using InvokeSolutions.Docx;
using System.Diagnostics;
using InvokeSolutions.Docx.Data;

namespace SampleArabic
{
    class Order
    {
        public String parcelnum { get; set; }
        public String Nlen { get; set; }
        public String Slen { get; set; }
        public String Elen { get; set; }
        public String Wlen { get; set; }
        public String NN { get; set; }
        public String SN { get; set; }
        public String EN { get; set; }
        public String WN { get; set; }
        public String AAA { get; set; }
        public po[] Po { get; set; }
        // image field. can be ImageDataItem also
        public byte[] rId7 { get; set; }
    }
    class po
    {
        public String p { get; set; }
        public String East { get; set; }
        public String north { get; set; }
    }

    class Program
    {
        static void Main(string[] args)
        {
            // create a copy of template file
            File.Copy("template.docx", "report.docx", true);

            // create datasource
            DocumentDataSource source = new DocumentDataSource();

            source["rep"] = DataItem.ConvertFrom(new[] { 
                   new Order{
                    AAA ="AAA1",
                     Elen = "Elen1", 
                      EN = "EN1",
                       Nlen = "Nlen1",
                        NN = "NN1",
                         parcelnum = "parcelnum1",
                          Slen = "Slen1",
                           SN ="SN1",
                            Wlen = "Wlen1",
                             WN = "WN1",
                              rId7 = File.ReadAllBytes("1.png"),
                       Po = new [] {new po{ East = "East1.1", north = "north1.1", p =  "p1.1"},  
                           new po{ East = "East1.2", north = "north1.2", p =  "p1.2"}}
                   },
                new Order{
                    AAA ="AAA2",
                     Elen = "Elen2", 
                      EN = "EN2",
                      Nlen = "Nlen2",
                        NN = "NN2",
                         parcelnum = "parcelnum2",
                          Slen = "Slen2",
                           SN ="SN2",
                            Wlen = "Wlen2",
                             WN = "WN2",
                             rId7 = File.ReadAllBytes("2.png"),
                                             Po = new [] {new po{ East = "East2.1", north = "north2.1", p =  "p2.1"},  
                           new po{ East = "East2.2", north = "north2.2", p =  "p2.2"}}
                   }
                }
            );

            // process the document
            DocumentRenderer.ProcessDocument("report.docx", source);

            Process.Start("report.docx");
        }
    }
}
