﻿using System.Diagnostics;
using System.IO;
using System.Data;
using System;
using System.Xml;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using InvokeSolutions.Docx;
using InvokeSolutions.Docx.Data;

namespace Sample0
{
    /// <summary>
    /// Sample class containing some data
    /// </summary>
    class Order
    {
        public int Invoice_Id { get; set; }
        public DateTime Date { get; set; }
        public Customer Customer { get; set; }
        public string Service { get; set; }
        public int Quantity { get; set; }
        public decimal Amount { get; set; }
    }

    class Customer
    {
        public string Email { get; set; }
        public string Name { get; set; }
    }

    class Program
    {
        [STAThread]
        static void Main()
        {
            

            File.Copy("templates\\order.docx", "compiled\\order_compiled.docx", true);

            // create new order entity
            Order order = new Order
            {
                Amount = 100,
                Date = DateTime.Today,
                Customer = new Customer { Name = "FBI", Email = "fbi@gmail.com" },
                Invoice_Id = 55,
                Quantity = 1,
                Service = "Delivering Bin Laden to Guantanamo"
            };

            // create datasource from the entity
            // property names will be used as parameter names
            DocumentDataSource dataSource = new DocumentDataSource();

            dataSource["order"] = DataItem.ConvertFrom(order);

            // it is equal to
            /*
             DocumentDataSource dataSource = new DocumentDataSource();
             dataSource["Amount"] = 100;
             dataSource["Date"] = DateTime.Today;
             dataSource["Customer"] = "FBI";
             dataSource["Invoice_Id"] = 55;
             dataSource["Quantity"] = 1;
             dataSource["Service"] = "Delivering Bin Laden to Guantanamo";
            */

            // process document
            DocumentRenderer.ProcessDocument("compiled\\order_compiled.docx", dataSource);

            // launch ms word
            Process.Start("compiled\\order_compiled.docx");
        }
    }
}